/**
 * Gaming Tools
 * Copyright (C) 2003  Michael Birken
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * @author Michael Birken (o__1@hotmail.com)
 * @version 2.1
 */
package gamingtools;

/**
 * A class implements this interface to receive notification that an
 * exception has occurred. This is typically used for communication
 * of an error from one thread to another.
 * @see gamingtools.GraphicsSource
 */
public interface ExceptionHandler {

  /**
   * Called back an <CODE>Exception</CODE> or an <CODE>Error</CODE> happens.
   * @param t The <CODE>Exception</CODE> or <CODE>Error</CODE>.
   */
  public void exceptionOccurred(Throwable t);
}