/**
 * Meat Fighter
 * Copyright (C) 2003  Michael Birken
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * Meat Fighter and JaminWare are trademarks of Michael Birken.
 * All Rights Reserved.
 * http://www.meatfighter.com
 * o__1@hotmail.com
 */
package meatfighter;

import java.util.Random;

public class Chaotic {

  public static final int LENGTH = 10000;

  private static final int[] VALUES = new int[LENGTH];
  private static final Random RANDOM = new Random();
  private static int index;

  public static void refresh() {
    for(int i = 0; i < LENGTH; i++)
      VALUES[i] = Math.abs(RANDOM.nextInt());
  }

  public static int nextInt(int min, int max) {
    if (index >= LENGTH)
      index = 0;
    else
      index++;

    return (VALUES[index] % (max - min + 1)) + min;
  }

  private Chaotic() {
  }

  static {
    refresh();
  }
}