/**
 * Meat Fighter
 * Copyright (C) 2003  Michael Birken
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * Meat Fighter and JaminWare are trademarks of Michael Birken.
 * All Rights Reserved.
 * http://www.meatfighter.com
 * o__1@hotmail.com
 */
package meatfighter;

import gamingtools.*;
import java.awt.event.ActionEvent;
import java.awt.*;
import javax.swing.*;
import java.awt.event.*;

public class Continue extends FrameBuilder {

  private class StartListener extends InputAdapter {
    public void inputStart() {
      startPressed = true;
      InputFactory.getInputSource().clearInputListener();
      MeatFighter.getInstance().continueTheGame();
    }
  };

  int seg[][] = { { 32, 0, 0 }, { 0, 32, 1 }, { 207, 32, 1 }, { 32, 207, 0 },
      { 0, 239, 1 }, { 207, 239, 1 }, { 32, 414, 0 } };
  boolean num[][] = { { true, true, true, false, true, true, true },
      { false, false, true, false, false, true, false },
      { true, false, true, true, true, false, true },
      { true, false, true, true, false, true, true },
      { false, true, true, true, false, true, false },
      { true, true, false, true, false, true, true },
      { true, true, false, true, true, true, true },
      { true, false, true, false, false, true, false },
      { true, true, true, true, true, true, true },
      { true, true, true, true, false, true, true } };

  Image fr[] = new Image[2], insertCoin;
  int ticks = 24, digit = 9, e = 6, oy, digitOld = 9;
  boolean animating = true, musicStopped, startPressed;
  Audio musicContinue;

  public void init() {

    musicContinue = Jukebox.MUSIC_CONTINUE;
    insertCoin = Gallery.TEXT_PRESS_ENTER;
    fr[0] = Gallery.SALAMI_HORZ;
    fr[1] = Gallery.SALAMI_VERT;
    oy = (640 - this.insertCoin.getWidth(null)) >> 1;

    for(int i = 0; i < 7; i++) {
      seg[i][0] += 200;
      seg[i][1] += 17;
    }

    InputFactory.getInputSource().setInputListener(new StartListener());

    musicContinue.setAudioListener(new AudioListener() {
      public void audioStopped() {
        musicStopped = true;
      }
    });
    Jukebox.playMusic(musicContinue);
  }

  public void updateState() {
    if (animating == false) {
      if (musicStopped)
        MeatFighter.getInstance().resetTheGame();
      return;
    }

    if (startPressed) {
      e = 0;
      return;
    }

    if (e-- == 0)
      e = 6;

    if (--ticks == 0) {
      ticks = 29;
      digitOld = digit;
      if (--digit == -1)
        animating = false;
    }
  }

  public boolean isBackgroundSame() {
    if (animating == false)
      return true;
    return (digitOld == digit);
  }

  public void renderBackground(Graphics g) {
    if (animating == false)
      return;

    g.setColor(Color.BLACK);
    g.fillRect(0, 0, 640, 480);
    for(int i = 0; i < 7; i++)
      if (num[digit][i])
        g.drawImage(fr[seg[i][2]], seg[i][0], seg[i][1], null);
  }

  public void renderBackground(
      Graphics g, int x, int y, int width, int height) {
    renderBackground(g);
  }

  public void renderForeground(Graphics g) {
    if (e >= 3)
      drawSprite(g, insertCoin, oy, 390);
  }
}