/**
 * Meat Fighter
 * Copyright (C) 2003  Michael Birken
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * Meat Fighter and JaminWare are trademarks of Michael Birken.
 * All Rights Reserved.
 * http://www.meatfighter.com
 * o__1@hotmail.com
 */
package meatfighter;

import gamingtools.*;
import java.awt.*;

public final class Gallery {

  public static final Image[] ARM;
  public static final Image BACKGROUND_VS;
  public static final Image BACKGROUND_BONUS_STAGE;
  public static final Image BACKGROUND_CHEESE;
  public static final Image[] BACKGROUND_STAGE;
  public static final Image BACKGROUND_NAMEUP;
  public static final Image[] BACKGROUND_WIN;
  public static final Image[] BEEF;
  public static final Image[][] CORNELIUS;
  public static final Image FIGHTERS;
  public static final Image[][] HOT;
  public static final Image[][] HUMAN_BEEF;
  public static final Image JAMINWARE;
  public static final Image[] JUMPING_FIGHTER;
  public static final Image[][] OLIVER;
  public static final Image[][] ORNAMENT;
  public static final Image[][] OSCAR;
  public static final Image[][] PORTRAIT;
  public static final Image[][] RAT;
  public static final Image[][] SAL;
  public static final Image SALAMI_HORZ;
  public static final Image SALAMI_VERT;
  public static final Image[] SHADOW;
  public static final Image[] SHADOW_C;
  public static final Image TEXT_BONUS_STAGE;
  public static final Image TEXT_CHOOSE_YOUR_PLAYER;
  public static final Image TEXT_DIRECTOR;
  public static final Image TEXT_GRAPHICS_ARTIST;
  public static final Image TEXT_MEAT_FIGHTER;
  public static final Image TEXT_MICHAEL_BIRKEN;
  public static final Image[][] TEXT_NAME;
  public static final Image TEXT_PRESS_ENTER;
  public static final Image TEXT_PROGRAMMER;
  public static final Image TEXT_READY;
  public static final Image[] TEXT_WIENER_WARRIOR;
  public static final Image TEXT_VS;
  public static final Image TEXT_THANKS_FOR_PLAYING;
  public static final Image TEXT_THE_END;
  public static final Image TOASTY;
  public static final Image TROPHY;

  static {

    // Beef
    BEEF = new Image[3];
    for(int i = 0; i < 3; i++)
      BEEF[i] = loadImage("beef"+(i+1)+".gif");

    // BonusStage
    BACKGROUND_VS = loadImage("vsback.gif");
    TEXT_BONUS_STAGE = loadImage("vsbs.gif");
    TOASTY = loadImage("toasty.gif");
    TEXT_READY = loadImage("ready.gif");
    BACKGROUND_BONUS_STAGE = loadImage("backgroundbs.gif");

    // Continue
    TEXT_PRESS_ENTER = loadImage("enter.gif");
    SALAMI_HORZ = loadImage("horz.gif");
    SALAMI_VERT = loadImage("vert.gif");

    // Cornelius
    String[] cornelius = { "CorneliusWalk1", "CorneliusWalk2", "CorneliusWalk3",
        "CorneliusWalk4", "CorneliusPunch1", "CorneliusPunch2",
        "CorneliusKick1", "CorneliusHurt1", "CorneliusBlock1", "CorneliusDead1",
        "CorneliusWin1" };
    CORNELIUS = new Image[2][];
    CORNELIUS[0] = loadImages(cornelius, ".gif");
    CORNELIUS[1] = loadImages(cornelius, "R.gif");

    // DemoStage
    String[] ornament = { "back1smoke", "back2fire", "back3bird", "back4smoke",
        "back5crab", "back6mouse" };
    BACKGROUND_STAGE = new Image[6];
    ORNAMENT = new Image[6][2];
    for(int i = 0; i < 6; i++) {
      BACKGROUND_STAGE[i] = loadImage("background" + (i+1) + ".gif");
      ORNAMENT[i] = new Image[] {
        loadImage(ornament[i] + "1.gif"),
        loadImage(ornament[i] + "2.gif")
      };
    }

    // Hot
    String[] hot = { "HotWalk1", "HotWalk2", "HotWalk3", "HotWalk4",
        "HotPunch1", "HotPunch2", "HotKick1", "HotHurt1", "HotBlock1",
        "HotDead1", "HotWin1" };
    HOT = new Image[2][];
    HOT[0] = loadImages(hot, ".gif");
    HOT[1] = loadImages(hot, "R.gif");

    // HumanBeef
    GraphicsConfiguration graphicsConfiguration = GraphicsEnvironment
        .getLocalGraphicsEnvironment().getDefaultScreenDevice()
            .getDefaultConfiguration();
    HUMAN_BEEF = new Image[2][3];
    for(int i = 0; i < 3; i++) {
      HUMAN_BEEF[1][i] = BEEF[i];
      HUMAN_BEEF[0][i] = graphicsConfiguration.createCompatibleImage(
          HUMAN_BEEF[1][i].getWidth(null), HUMAN_BEEF[1][i].getHeight(null),
              Transparency.BITMASK);
      Graphics g = null;
      try {
        g = HUMAN_BEEF[0][i].getGraphics();
        g.drawImage(HUMAN_BEEF[1][i], 0, 0,
            HUMAN_BEEF[1][i].getWidth(null),
            HUMAN_BEEF[1][i].getHeight(null),
            HUMAN_BEEF[1][i].getWidth(null), 0, 0,
            HUMAN_BEEF[1][i].getHeight(null), null);
      } finally {
        if (g != null)
          g.dispose();
      }
    }

    // Introduction
    JAMINWARE = loadImage("JaminWare.gif");
    BACKGROUND_CHEESE = loadImage("CheeseBack.gif");
    BACKGROUND_NAMEUP = loadImage("nameup.gif");
    JUMPING_FIGHTER = new Image[] {
        loadImage("Foreground1.gif"),
        loadImage("Foreground2.gif")
    };
    ARM = new Image[] {
        loadImage("CheeseArm1.gif"),
        loadImage("CheeseArm2.gif")
    };
    TEXT_MEAT_FIGHTER = loadImage("title.gif");
    TEXT_WIENER_WARRIOR = new Image[] {
        loadImage("warrior1.gif"),
        loadImage("warrior2.gif")
    };

    // Oliver
    String[] oliver = { "OliverWalk1", "OliverWalk2", "OliverWalk3",
        "OliverWalk4", "OliverPunch1", "OliverPunch2", "OliverKick1",
        "OliverHurt1", "OliverBlock1", "OliverDead1", "OliverWin1" };
    OLIVER = new Image[2][];
    OLIVER[0] = loadImages(oliver, ".gif");
    OLIVER[1] = loadImages(oliver, "R.gif");

    // Oscar
    String[] oscar = { "OscarWalk1", "OscarWalk2", "OscarWalk3", "OscarWalk4",
        "OscarPunch1", "OscarPunch2", "OscarHead1", "OscarHurt1",
        "OscarBlock1", "OscarDead1", "OscarWin1" };
    OSCAR = new Image[2][];
    OSCAR[0] = loadImages(oscar, ".gif");
    OSCAR[1] = loadImages(oscar, "R.gif");

    // Rat
    String[] rat = { "RatWalk1", "RatWalk2", "RatWalk3", "RatWalk4",
            "RatPunch1", "RatPunch2", "RatKick1", "RatHurt1",
            "RatBlock1", "RatDead1", "RatWin1" };
    RAT = new Image[2][];
    RAT[0] = loadImages(rat, ".gif");
    RAT[1] = loadImages(rat, "R.gif");

    // Sal
    String[] sal = { "SalWalk1", "SalWalk2", "SalWalk3", "SalWalk4",
        "SalPunch1", "SalPunch2", "SalKick1", "SalKick2",
        "SalHurt1", "SalBlock1", "SalDead1", "SalWin1" };
    SAL = new Image[2][];
    SAL[0] = loadImages(sal, ".gif");
    SAL[1] = loadImages(sal, "R.gif");

    // SelectCharacter
    TEXT_CHOOSE_YOUR_PLAYER = loadImage("choose.gif");
    TEXT_NAME = new Image[2][3];
    TEXT_NAME[0][0] = loadImage("CorneliusName.gif");
    TEXT_NAME[0][1] = loadImage("OliverName.gif");
    TEXT_NAME[0][2] = loadImage("RatName.gif");
    TEXT_NAME[1][0] = loadImage("SalName.gif");
    TEXT_NAME[1][1] = loadImage("OscarName.gif");
    TEXT_NAME[1][2] = loadImage("HotName.gif");
    FIGHTERS = loadImage("all.gif");

    // VS
    TEXT_VS = loadImage("vs.gif");
    PORTRAIT = new Image[6][2];
    PORTRAIT[0][0] = loadImage("SalPortrait.gif");
    PORTRAIT[0][1] = loadImage("SalPortraitR.gif");
    PORTRAIT[1][0] = loadImage("RatPortrait.gif");
    PORTRAIT[1][1] = loadImage("RatPortraitR.gif");
    PORTRAIT[2][0] = loadImage("OscarPortrait.gif");
    PORTRAIT[2][1] = loadImage("OscarPortraitR.gif");
    PORTRAIT[3][0] = loadImage("HotPortrait.gif");
    PORTRAIT[3][1] = loadImage("HotPortraitR.gif");
    PORTRAIT[4][0] = loadImage("CorneliusPortrait.gif");
    PORTRAIT[4][1] = loadImage("CorneliusPortraitR.gif");
    PORTRAIT[5][0] = loadImage("OliverPortrait.gif");
    PORTRAIT[5][1] = loadImage("OliverPortraitR.gif");

    // WinningScene
    TROPHY = loadImage("WinCup.gif");
    TEXT_DIRECTOR = loadImage("Director.gif");
    TEXT_GRAPHICS_ARTIST = loadImage("GraphicsArtist.gif");
    TEXT_MICHAEL_BIRKEN = loadImage("MichaelBirken.gif");
    TEXT_THE_END = loadImage("TheEnd.gif");
    TEXT_PROGRAMMER = loadImage("Programmer.gif");
    TEXT_THANKS_FOR_PLAYING = loadImage("Thanks.gif");
    BACKGROUND_WIN = new Image[4];
    for(int i = 0; i < 4; i++)
      BACKGROUND_WIN[i] = loadImage("Win" + (i+1) + ".gif");
    SHADOW_C = new Image[3];
    for(int i = 0; i < 3; i++)
      SHADOW_C[i] = loadImage("ShadowCWalk" + (i+1) + ".gif");
    SHADOW = new Image[3];
    for(int i = 0; i < 3; i++)
      SHADOW[i] = loadImage("ShadowWalk" + (i+1) + ".gif");
  }

  private static Image[] loadImages(String[] names, String suffix) {
    Image[] imgs = ImageSource.getImages(names, suffix);
    ProgressBar.fileCount += names.length;
    return imgs;
  }

  private static Image loadImage(String fileName) {
    Image img = ImageSource.getImage(fileName);
    ProgressBar.fileCount++;
    return img;
  }
}