/**
 * Meat Fighter
 * Copyright (C) 2003  Michael Birken
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * Meat Fighter and JaminWare are trademarks of Michael Birken.
 * All Rights Reserved.
 * http://www.meatfighter.com
 * o__1@hotmail.com
 */
package meatfighter;

import gamingtools.*;
import java.awt.*;

public class ProgressBar implements RenderListener {

  public static int fileCount;

  private int[] lastProgress;
  private int bufferWidth;
  private int bufferHeight;
  private double ratio;

  public void init(boolean isPageFlipping, int bufferWidth, int bufferHeight) {
    fileCount = 0;
    lastProgress = new int[isPageFlipping ? 2 : 1];
    ratio = (bufferWidth - 32) / 238.0;
    this.bufferWidth = bufferWidth;
    this.bufferHeight = bufferHeight;
  }

  public void updateModel() {
  }

  public void render(Graphics g, boolean isBufferCleared, int bufferIndex) {
    //if (isBufferCleared) {
      g.setColor(Color.BLACK);
      g.fillRect(0, 0, bufferWidth, bufferHeight);
      g.setColor(Color.DARK_GRAY);
      g.fill3DRect(15, bufferHeight - 33, bufferWidth - 30, 18, false);
    //}

    int progress = fileCount;
    //if (lastProgress[bufferIndex] == progress)
    //  return;
    lastProgress[bufferIndex] = progress;

    g.setColor(Color.GREEN);
    g.fill3DRect(16, bufferHeight - 32, (int)(progress * ratio), 16, true);
  }
}