/**
 * Meat Fighter
 * Copyright (C) 2003  Michael Birken
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * Meat Fighter and JaminWare are trademarks of Michael Birken.
 * All Rights Reserved.
 * http://www.meatfighter.com
 * o__1@hotmail.com
 */
package meatfighter;

import gamingtools.*;
import java.awt.*;
import java.applet.*;

public class Sal implements IFighter {
    Image fr[][] = new Image[2][12];
    int x = 10, deaths = 0;
    int wp[] = { 0, 0, 1, 1, 2, 2, 3, 3, 2, 2, 1, 1}, wpi = 0;
    int sn[] = { 2, 3, 2, 4, 4, 3, 2, 4, 4 }, sni = 0;
    int pn = 0, kn = 0, jn = 0, diff, dazed = 0;
    int jump[] = new int[12];
    int orientation = 0;
    IFighter opponent;
    boolean blocked = false, punched = false;
    int fear = Chaotic.nextInt(10, 59);
    int jmp = Chaotic.nextInt(10, 29), pnch = Chaotic.nextInt(1, 10);
    int punches = Chaotic.nextInt(5, 9), blocking = 0, vitality = 300;
    boolean afraid, auto, winner = false, leftFighter;
    Image currentImage;

    public boolean isDead() {
        return deaths == 2;
    }

    public void setWinner() {
        winner = true;
    }

    public void resetVitality() {
        afraid = false; punched = true; blocked = false; winner = false;
        jmp = Chaotic.nextInt(10, 29); pnch = Chaotic.nextInt(1, 5);
        fear = Chaotic.nextInt(10, 59);
        pn = kn = jn = dazed = blocking = 0;
        vitality = 300;
        if (leftFighter) {
            x = 10;
            orientation = 0;
        } else {
            x = 500;
            orientation = 1;
        }
    }

    public int getVitality() {
        return vitality;
    }

    public void setAutomatic(boolean auto) {
        this.auto = auto;
    }

    public void setFighter(boolean leftFighter) {
        this.leftFighter = leftFighter;
        if (leftFighter) {
            x = 10;
            orientation = 0;
        } else {
            x = 500;
            orientation = 1;
        }
    }

    public void init() {
        int i;
        for(i = 2; i <= 6; i++)
            jump[7 - i] = jump[4 + i] = (int)(((double)(i*i))*8.5) - 102;
        jump[0] = jump[11] = 204;

        fr[0] = Gallery.SAL[0];
        fr[1] = Gallery.SAL[1];
    }

    public void block() {
        if (dazed == 0)
            blocked = true;
    }

    public void unblock() {
        if (blocked) {
            blocked = false;
            wpi = 0;
        }
    }

    public void damage() {
        if (vitality == 0 || winner)
            return;

        punched = true;
        pn = kn = 0;
        if (auto) {
            afraid = true;
            if (dazed > 3) {
                blocking = fear;
                dazed = 0;
            } else if (blocking == 0) {
                dazed += 5;
                if (vitality > 0)
                    vitality -= 10;
                if (vitality <= 0) {
                    opponent.setWinner();
                    vitality = 0;
                    deaths++;
                    if (deaths == 2)
                        Jukebox.OUCH.play();
                    else if (Chaotic.nextInt(0, 1) == 0)
                        Jukebox.GIBBER3.play();
                    else
                        Jukebox.GIBBER.play();
                }
            }
        } else {
            if (blocked == false) {
                dazed += 5;
                if (vitality > 0)
                    vitality -= 10;
                if (vitality <= 0) {
                    opponent.setWinner();
                    vitality = 0;
                    deaths++;
                    if (deaths == 2)
                        Jukebox.OUCH.play();
                    else if (Chaotic.nextInt(0, 1) == 0)
                        Jukebox.GIBBER3.play();
                    else
                        Jukebox.GIBBER.play();
                }
            }
        }
    }

    public void setOpponent(IFighter opponent) {
        this.opponent = opponent;
    }

    public int getX() {
        return x;
    }

    public int getY() {
        return jump[jn];
    }

    public void update(int otherX, int diff) {
        this.diff = diff;

        if (diff > 20)
            orientation = (x < otherX) ? 0 : 1;
        if (diff < 70 && jn == 0)
            if (orientation == 0) {
                if (x > 0)
                    x -= 25;
            } else if (x < 520)
                x += 25;

        if (vitality == 0 || winner) {
            if (diff < 140)
                if (orientation == 0) {
                    if (x > 0)
                        x -= 25;
                } else if (x < 520)
                    x += 25;
            return;
        }
    }

    public void update() {
        if (jn > 0 && ++jn > 10) {
            wpi = 1;
            jn = 0;
        }

        if (dazed > 0 || (vitality == 0 && deaths == 1)) {
            dazed--;
            currentImage = fr[orientation][8];
            return;
        } else if (vitality == 0) {
            currentImage = fr[orientation][10];
            return;
        } else if (winner) {
            currentImage = fr[orientation][11];
            return;
        } else if (pn > 0) {
            if (pn < 3) {
                pn++;
                currentImage = fr[orientation][4];
                return;
            } else if (pn == 4 || pn == 5) {
                pn++;
                currentImage = fr[orientation][5];
                return;
            } else if (pn > 5)
                pn = 0;
        } else if (kn > 0) {
            if (kn < 3) {
                kn++;
                currentImage = fr[orientation][3];
                return;
            } else if (kn < 5) {
                kn++;
                currentImage = fr[orientation][6];
                return;
            } else if (kn < 7) {
                kn++;
                currentImage = fr[orientation][7];
                return;
            } else
                kn = 0;
        }
        if (blocked || blocking > 0) {
            currentImage = fr[orientation][9];
            return;
        }
        currentImage = fr[orientation][wp[wpi]];
    }

    public Image getImage() {
      return currentImage;
    }

    public void moveLeft() {
        if (vitality == 0 || winner)
            return;

        if (jn == 0 && orientation == 1 && diff < 70)
            return;
        if (x > 0)
            if (jn == 0)
                x -= 15;
            else
                x -= 25;
        if (jn == 0 && ++wpi == 10)
            wpi = 0;
    }

    public void moveRight() {
        if (vitality == 0 || winner)
            return;

        if (jn == 0 && orientation == 0 && diff < 70)
            return;
        if (x < 520)
            if (jn == 0)
                x += 15;
            else
                x += 25;
        if (jn == 0 && ++wpi == 10)
            wpi = 0;
    }

    public boolean isPunched() {
        return punched;
    }

    public void punch() {
        if (vitality == 0 || winner)
            return;

        if (dazed == 0) {
            punched = false;
            wpi = 0;
            kn = 0;
            pn++;
            if (diff < 90) {
                punched = false;
                opponent.damage();
                if (sni > 5)
                    sni = 0;
                else
                    sni++;
                Jukebox.PUNCH[sn[sni]].play();
            } else if (pn == 1)
                Jukebox.PUNCH1.play();
            else if (pn == 4)
                Jukebox.PUNCH2.play();
        }
    }

    public void kick() {
        if (vitality == 0 || winner)
            return;

        if (dazed == 0) {
            punched = false;
            wpi = 6;
            pn = 0;
            kn++;
            if (diff < 100) {
                punched = false;
                opponent.damage();
                if (sni > 5)
                    sni = 0;
                else
                    sni++;
                Jukebox.PUNCH[sn[sni]].play();
            } else
                Jukebox.PUNCH1.play();
        }
    }

    public void jump() {
        if (jn == 0) {
            punched = false;
            wpi = 2;
            jn++;
        }
    }

    public void update(int salX, int oscarX, int diff) {

        if (diff > 20)
            orientation = (salX < oscarX) ? 1 : 0;
        if (diff < 70 && jn == 0)
            if (orientation == 0) {
                if (x > 0)
                    x -= 25;
            } else if (x < 520)
                x += 25;

        if (vitality == 0 || winner) {
            if (diff < 140)
                if (orientation == 0) {
                    if (x > 0)
                        x -= 25;
                } else if (x < 520)
                    x += 25;
            return;
        }

        if (blocking == 0) {
            if (dazed == 0 && pnch == 0 && kn == 0 && (pn == 0 || pn == 3)
                    && diff < 110) {
                pnch = Chaotic.nextInt(1, 10);
                if (diff < 90) {
                    punched = false;
                    opponent.damage();
                    if (sni > 5)
                        sni = 0;
                    else
                        sni++;
                    Jukebox.PUNCH[sn[sni]].play();
                } else if (diff < 50)
                    afraid = true;
                if (punches == 0) {
                    Jukebox.PUNCH1.play();
                    kn++;
                    pn = 0;
                    punches = Chaotic.nextInt(5, 9);
                } else {
                    pn++;
                    punches--;
                    if (pn == 1)
                        Jukebox.PUNCH1.play();
                    else if (pn == 4)
                        Jukebox.PUNCH2.play();
                }
            } else if (pnch > 0)
                pnch--;

            if (salX < oscarX)
                if (afraid) {
                    if (oscarX < 520)
                        x += ((jn > 0) ? 25 : 15);
                } else {
                    if (oscarX > 0)
                        x -= ((jn > 0) ? 25 : 15);
                }
            else
                if (afraid) {
                    if (oscarX > 0)
                        x -= ((jn > 0) ? 25 : 15);
                } else
                    if (oscarX < 520)
                        x += ((jn > 0) ? 25 : 15);
        }

        if (--fear == 0) {
            afraid = !afraid;
            if (afraid == false)
                blocking = 0;
            fear = Chaotic.nextInt(10, 59);
        } else if (blocking > 0)
            blocking--;

        if (jn == 0 && --jmp == 0) {
          jmp = Chaotic.nextInt(10, 29);
          jn = 1;
          wpi = 0;
        }

        if (jn == 0 && ++wpi == 10)
            wpi = 0;
    }

}